diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index c64ed88a3..305cbeb04 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.enums.EnumDropCause;
@@ -8,105 +9,95 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.*;
 
-public class ExplosionCannonball extends Explosion{
+public class ExplosionCannonball extends Explosion {
 
-    public ExplosionCannonball(World world, Entity entity, double d, double d1, double d2, float f)
-    {
-        super(world, entity, d, d1, d2, f);
+    public ExplosionCannonball(@NotNull World world, @Nullable Entity exploder, double x, double y, double z, float explosionSize) {
+        super(world, exploder, x, y, z, explosionSize);
     }
 
     @Override
-	public void explode()
-    {
+    public void explode() {
         int i = 16;
-        for(int j = 0; j < i; j++)
-        {
-            for(int l = 0; l < i; l++)
-            {
+        for (int j = 0; j < i; j++) {
+            for (int l = 0; l < i; l++) {
                 label0:
-                for(int j1 = 0; j1 < i; j1++)
-                {
-                    if(j != 0 && j != i - 1 && l != 0 && l != i - 1 && j1 != 0 && j1 != i - 1)
-                    {
+                for (int j1 = 0; j1 < i; j1++) {
+                    if (j != 0 && j != i - 1 && l != 0 && l != i - 1 && j1 != 0 && j1 != i - 1) {
                         continue;
                     }
-                    double d = ((float)j / ((float)i - 1.0F)) * 2.0F - 1.0F;
-                    double d1 = ((float)l / ((float)i - 1.0F)) * 2.0F - 1.0F;
-                    double d2 = ((float)j1 / ((float)i - 1.0F)) * 2.0F - 1.0F;
+                    double d = ((float) j / ((float) i - 1.0F)) * 2.0F - 1.0F;
+                    double d1 = ((float) l / ((float) i - 1.0F)) * 2.0F - 1.0F;
+                    double d2 = ((float) j1 / ((float) i - 1.0F)) * 2.0F - 1.0F;
                     double d3 = java.lang.Math.sqrt(d * d + d1 * d1 + d2 * d2);
                     d /= d3;
                     d1 /= d3;
                     d2 /= d3;
-                    float f1 = explosionSize * (0.7F + worldObj.rand.nextFloat() * 0.6F);
-                    double d5 = explosionX;
-                    double d7 = explosionY;
-                    double d9 = explosionZ;
+                    float f1 = this.explosionSize * (0.7F + this.world.rand.nextFloat() * 0.6F);
+                    double d5 = this.explosionX;
+                    double d7 = this.explosionY;
+                    double d9 = this.explosionZ;
                     float f2 = 0.3F;
-                    do
-                    {
-                        if(f1 <= 0.0F)
-                        {
+                    do {
+                        if (f1 <= 0.0F) {
                             continue label0;
                         }
                         int j4 = MathHelper.floor(d5);
                         int k4 = MathHelper.floor(d7);
                         int l4 = MathHelper.floor(d9);
-                        int i5 = worldObj.getBlockId(j4, k4, l4);
-                        if(i5 > 0)
-                        {
-                            f1 -= (Blocks.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
+                        int i5 = this.world.getBlockId(j4, k4, l4);
+                        if (i5 > 0) {
+                            f1 -= (Blocks.blocksList[i5].getBlastResistance(this.exploder) + 0.3F) * f2;
                         }
-                        if(f1 > 0.0F)
-                        {
-                            destroyedBlockPositions.add(new ChunkPosition(j4, k4, l4));
+                        if (f1 > 0.0F) {
+                            this.destroyedBlockPositions.add(new ChunkPosition(j4, k4, l4));
                         }
-                        d5 += d * (double)f2;
-                        d7 += d1 * (double)f2;
-                        d9 += d2 * (double)f2;
+                        d5 += d * (double) f2;
+                        d7 += d1 * (double) f2;
+                        d9 += d2 * (double) f2;
                         f1 -= f2 * 0.75F;
-                    } while(true);
+                    } while (true);
                 }
 
             }
 
         }
 
-        explosionSize *= 2.0F;
-        int k = MathHelper.floor(explosionX - (double)explosionSize - 1.0D);
-        int i1 = MathHelper.floor(explosionX + (double)explosionSize + 1.0D);
-        int k1 = MathHelper.floor(explosionY - (double)explosionSize - 1.0D);
-        int l1 = MathHelper.floor(explosionY + (double)explosionSize + 1.0D);
-        int i2 = MathHelper.floor(explosionZ - (double)explosionSize - 1.0D);
-        int j2 = MathHelper.floor(explosionZ + (double)explosionSize + 1.0D);
-//        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getBoundingBoxFromPool(k, k1, i2, i1, l1, j2));
-        List<Entity> list = worldObj.getEntitiesWithinAABB(Entity.class, AABB.fromPool(k, k1, i2, i1, l1, j2)); // Cannon balls can explode their owners
-        Vec3 vec3 = Vec3.fromPool(explosionX, explosionY, explosionZ);
-        for(int k2 = 0; k2 < list.size(); k2++)
-        {
+        this.explosionSize *= 2.0F;
+        int minX = MathHelper.floor(this.explosionX - (double) this.explosionSize - 1.0D);
+        int maxX = MathHelper.floor(this.explosionX + (double) this.explosionSize + 1.0D);
+        int minY = MathHelper.floor(this.explosionY - (double) this.explosionSize - 1.0D);
+        int maxY = MathHelper.floor(this.explosionY + (double) this.explosionSize + 1.0D);
+        int minZ = MathHelper.floor(this.explosionZ - (double) this.explosionSize - 1.0D);
+        int maxZ = MathHelper.floor(this.explosionZ + (double) this.explosionSize + 1.0D);
+//        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getBoundingBoxFromPool(minX, minY, minZ, maxX, maxY, maxZ));
+        List<Entity> list = this.world.getEntitiesWithinAABB(Entity.class, new AABBd(minX, minY, minZ, maxX, maxY, maxZ)); // Cannon balls can explode their owners
+        Vector3dc vec3 = new Vector3d(this.explosionX, this.explosionY, this.explosionZ);
+        for (int k2 = 0; k2 < list.size(); k2++) {
             Entity entity = list.get(k2);
-            double d4 = entity.distanceTo(explosionX, explosionY, explosionZ) / (double)explosionSize;
-            if(d4 <= 1.0D)
-            {
-                double xComp = entity.x - explosionX;
-                double yComp = entity.y - explosionY;
-                double zComp = entity.z - explosionZ;
+            double d4 = entity.distanceTo(this.explosionX, this.explosionY, this.explosionZ) / (double) this.explosionSize;
+            if (d4 <= 1.0D) {
+                double xComp = entity.x - this.explosionX;
+                double yComp = entity.y - this.explosionY;
+                double zComp = entity.z - this.explosionZ;
                 double d11 = MathHelper.sqrt(xComp * xComp + yComp * yComp + zComp * zComp);
                 xComp *= 2.5;
                 yComp /= d11;
                 yComp += 0.5f;
                 zComp *= 2.5;
-                double d12 = worldObj.getSeenPercent(vec3, entity.bb);
+                double d12 = this.world.getSeenPercent(vec3, entity.bb);
                 double flingForce = (1.0D - d4) * d12;
-                entity.hurt(exploder, (int)(((flingForce * flingForce + flingForce) / 2D) * 8D * (double)explosionSize + 1.0D), DamageType.BLAST);
-                if (entity instanceof IArmorWearing && entity != exploder) {
+                entity.hurt(this.exploder, (int) (((flingForce * flingForce + flingForce) / 2D) * 8D * (double) this.explosionSize + 1.0D), DamageType.BLAST);
+                if (entity instanceof IArmorWearing && entity != this.exploder) {
                     float proc = 1 - (((IArmorWearing<?>) entity).getTotalProtectionAmount(DamageType.BLAST) / 2f);
                     flingForce *= proc;
                 }
@@ -114,20 +105,17 @@ public class ExplosionCannonball extends Explosion{
             }
         }
 
-        ArrayList<ChunkPosition> arraylist = new ArrayList<>(destroyedBlockPositions);
-        if(isFlaming)
-        {
-            for(int l2 = arraylist.size() - 1; l2 >= 0; l2--)
-            {
+        ArrayList<ChunkPosition> arraylist = new ArrayList<>(this.destroyedBlockPositions);
+        if (this.isFlaming) {
+            for (int l2 = arraylist.size() - 1; l2 >= 0; l2--) {
                 ChunkPosition chunkposition = arraylist.get(l2);
                 int i3 = chunkposition.x;
                 int j3 = chunkposition.y;
                 int k3 = chunkposition.z;
-                int l3 = worldObj.getBlockId(i3, j3, k3);
-                int i4 = worldObj.getBlockId(i3, j3 - 1, k3);
-                if(l3 == 0 && Blocks.solid[i4] && ExplosionRNG.nextInt(3) == 0)
-                {
-                    worldObj.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id());
+                int l3 = this.world.getBlockId(i3, j3, k3);
+                int i4 = this.world.getBlockId(i3, j3 - 1, k3);
+                if (l3 == 0 && Blocks.solid[i4] && this.ExplosionRNG.nextInt(3) == 0) {
+                    this.world.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id());
                 }
             }
 
@@ -135,50 +123,46 @@ public class ExplosionCannonball extends Explosion{
     }
 
     @Override
-	public void addEffects(boolean flag)
-    {
-    	if(!worldObj.isClientSide) {
-    		worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, explosionX, explosionY, explosionZ, "random.explode", 4F, (1.0F + (worldObj.rand.nextFloat() - worldObj.rand.nextFloat()) * 0.2F) * 0.7F);	
-    	}
-        ArrayList<ChunkPosition> arraylist = new ArrayList<>(destroyedBlockPositions);
-        for(int i = arraylist.size() - 1; i >= 0; i--)
-        {
+    public void addEffects(boolean particles) {
+        if (!this.world.isClientSide) {
+            this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.explosionX, this.explosionY, this.explosionZ, "random.explode", 4F, (1.0F + (this.world.rand.nextFloat() - this.world.rand.nextFloat()) * 0.2F) * 0.7F);
+        }
+        ArrayList<ChunkPosition> arraylist = new ArrayList<>(this.destroyedBlockPositions);
+        for (int i = arraylist.size() - 1; i >= 0; i--) {
             ChunkPosition chunkposition = arraylist.get(i);
             int x = chunkposition.x;
             int y = chunkposition.y;
             int z = chunkposition.z;
-            Block<?> block = worldObj.getBlock(x, y, z);
-            TileEntity tileEntity = worldObj.getTileEntity(x, y, z);
-            if(flag)
-            {
-                double d = (double)x + worldObj.rand.nextFloat();
-                double d1 = (double)y + worldObj.rand.nextFloat();
-                double d2 = (double)z + worldObj.rand.nextFloat();
-                double d3 = d - explosionX;
-                double d4 = d1 - explosionY;
-                double d5 = d2 - explosionZ;
+            Block<?> block = this.world.getBlock(x, y, z);
+            TileEntity tileEntity = this.world.getTileEntity(x, y, z);
+            if (particles) {
+                double d = (double) x + this.world.rand.nextFloat();
+                double d1 = (double) y + this.world.rand.nextFloat();
+                double d2 = (double) z + this.world.rand.nextFloat();
+                double d3 = d - this.explosionX;
+                double d4 = d1 - this.explosionY;
+                double d5 = d2 - this.explosionZ;
                 double d6 = MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
                 d3 /= d6;
                 d4 /= d6;
                 d5 /= d6;
-                double d7 = 0.5D / (d6 / (double)explosionSize + 0.1D);
-                d7 *= worldObj.rand.nextFloat() * worldObj.rand.nextFloat() + 0.3F;
+                double d7 = 0.5D / (d6 / (double) this.explosionSize + 0.1D);
+                d7 *= this.world.rand.nextFloat() * this.world.rand.nextFloat() + 0.3F;
                 d3 *= d7;
                 d4 *= d7;
                 d5 *= d7;
-                worldObj.spawnParticle("explode", (d + explosionX) / 2D, (d1 + explosionY) / 2D, (d2 + explosionZ) / 2D, d3, d4, d5, 0 );
-                worldObj.spawnParticle("smoke", d, d1, d2, d3, d4, d5, 0);
+                this.world.spawnParticle("explode", (d + this.explosionX) / 2D, (d1 + this.explosionY) / 2D, (d2 + this.explosionZ) / 2D, d3, d4, d5, 0);
+                this.world.spawnParticle("smoke", d, d1, d2, d3, d4, d5, 0);
             }
-            if(block != null && (block == Blocks.GLASS
-                    ||  block.getMaterial() == Material.topSnow
-                    ||  block.getMaterial() == Material.plant
-                    ||  block.getMaterial() == Material.web
-                    ||  block.getMaterial() == Material.decoration
-                    ||  block.getMaterial() == Material.ice))
-            {
-                block.dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
-                worldObj.setBlockWithNotify(x, y, z, 0);
-                block.onBlockDestroyedByExplosion(worldObj, x, y, z);
+            if (block != null && (block == Blocks.GLASS
+                || block.getMaterial() == Materials.TOP_SNOW
+                || block.getMaterial() == Materials.PLANT
+                || block.getMaterial() == Materials.WEB
+                || block.getMaterial() == Materials.DECORATION
+                || block.getMaterial() == Materials.ICE)) {
+                block.dropBlockWithCause(this.world, EnumDropCause.EXPLOSION, x, y, z, this.world.getBlockMetadata(x, y, z), tileEntity, null);
+                this.world.setBlockWithNotify(x, y, z, 0);
+                block.onBlockDestroyedByExplosion(this.world, x, y, z);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java b/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
index 0d8597a8a..f6a4a168a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/MutableWorldSource.java
@@ -3,54 +3,55 @@ package net.minecraft.core.world;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public interface MutableWorldSource
     extends WorldSource {
 
-    boolean setBlockId(final @NotNull TilePos tilePos, final int id);
+    boolean setBlockId(final @NotNull TilePosc tilePos, final int id);
 
     @Deprecated
     default boolean setBlock(final int x, final int y, final int z, final int id) {
         return this.setBlockId(new TilePos(x, y, z), id);
     }
 
-    boolean setBlockData(final @NotNull TilePos tilePos, final int data);
+    boolean setBlockData(final @NotNull TilePosc tilePos, final int data);
 
     @Deprecated
     default boolean setBlockMetadata(final int x, final int y, final int z, final int data) {
         return this.setBlockData(new TilePos(x, y, z), data);
     }
 
-    boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data);
+    boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data);
 
     @Deprecated
     default boolean setBlockAndMetadata(final int x, final int y, final int z, final int id, final int data) {
         return this.setBlockIdData(new TilePos(x, y, z), id, data);
     }
 
-    void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos, final int value);
+    void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos, final int value);
 
     @Deprecated
     default void setLightValue(final @NotNull LightLayer lightLayer, final int x, final int y, final int z, final int value) {
         this.setLightValue(lightLayer, new TilePos(x, y, z), value);
     }
 
-    void setTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity);
+    void setTileEntity(final @NotNull TilePosc tilePos, final @NotNull TileEntity tileEntity);
 
     @Deprecated
     default void setTileEntity(final int x, final int y, final int z, final @NotNull TileEntity tileEntity) {
         this.setTileEntity(new TilePos(x, y, z), tileEntity);
     }
 
-    void removeTileEntity(final @NotNull TilePos tilePos);
+    void removeTileEntity(final @NotNull TilePosc tilePos);
 
     @Deprecated
     default void removeBlockTileEntity(final int x, final int y, final int z) {
         this.removeTileEntity(new TilePos(x, y, z));
     }
 
-    default void replaceTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+    default void replaceTileEntity(final @NotNull TilePosc tilePos, final @NotNull TileEntity tileEntity) {
         this.removeTileEntity(tilePos);
         this.setTileEntity(tilePos, tileEntity);
     }
